	PROGRAM GRID
C
C	Version 1.2, 2.4.1998, by M. Knappertsbusch.
C
C	. . .Single sample operation mode. . .
C
C	Verbesserte Version: Dimension der Matrizen erhoeht
C	(kann nun bis 60x60 gridding files machen).
C	DX und DY koennen jetzt variabel gewaehlt werden.
C	Bereich des Gridding geht von 0 - XMax in X Richtung,
C	und von                       0 - YMax in Y Richtung.
C	Ausgabe wurde verbessert.
C
C	Gridding program for C. leptoporus.
C	Program calculates bivariate frequencies from X,Y
C	data. Binwidth in X is DX (diameter), and in Y
C	it is DY (elements).
C
C	It applies the same grid as in Contour plot by
C	Dave Lazarus.
C
C	Arrays: FREQ(I,J), with I=Diameter (=X) and J=Elements (=Y).
C
C	LABELX andLABELY are to indicate the categories in the
C	output file.
C
C
	INTEGER FREQ(1:60,1:60)
	REAL LABELX(1:60),LABELY(1:60)
	REAL XMAX,YMAX
	INTEGER I,J
	INTEGER NX,NY
	REAL X,Y,DX,DY
	CHARACTER*20 INPUT,OUTPUT
C
	WRITE(9,*) '. . .Gridding X,Y data, version 1.2. . .'
	WRITE(9,*) '     Single sample operation mode'
	WRITE(9,*) ' '
	WRITE(9,*) '. . .Enter input file. . .'
	READ(9,1) INPUT
	WRITE(9,*) '. . .Enter output file. . .'
	READ(9,1) OUTPUT
 1	FORMAT(A20)
C
	WRITE(9,*) 'Enter upper limit of X and Y (Xmax,Ymax)'
	READ(9,*) XMAX,YMAX
	WRITE(9,*) 'Enter intervals (DX,DY)'
	READ(9,*) DX,DY
C
C	Determine number of intervals in X and Y direction
C
	NX=NINT(XMAX/DX)
	NY=NINT(YMAX/DY)
	WRITE(9,*) NX,' X-intervals'
	WRITE(9,*) NY,' Y-intervals'
C
	OPEN(15,FILE=INPUT,STATUS='OLD')
	OPEN(16,FILE=OUTPUT,STATUS='NEW')
C
C	Initialize FREQ (I=Diameter, J=Elements):
C
	DO 10,J=1,NY
	  DO 5, I=1,NX
	    FREQ(I,J)=0
 5	  CONTINUE
 10	CONTINUE
C
C
C	Determine Labels for X and Y values:
C
	DO 11, I=1,NX
	  LABELX(I)=I*DX
 11	CONTINUE
C
	DO 12, I=1,NY
	  LABELY(I)=I*DY
 12	CONTINUE
C
C
 15	READ(15,*,END=999) X,Y
C
C	Now gridding the data:
C	I runs for Diameter, J runs for Elements.
C
	DO 40, J=1,NY
	  DO 30, I=1,NX
	  IF (((J-1)*DY.LE.Y).AND.(Y.LT.J*DY)) THEN
	    IF (((I-1)*DX.LE.X).AND.(X.LT.I*DX)) THEN
	      FREQ(I,J)=FREQ(I,J)+1
	    END IF
	  END IF
 30	  CONTINUE
 40	CONTINUE
	GOTO 15
C
C	Writing results to output file:
C
 999	WRITE(16,50) INPUT
 	WRITE(16,*) 'DX = ',DX,' DY = ',DY
 	WRITE(16,70) '   ',(LABELX(I)-DX,'-',LABELX(I),I=1,NX)
 	WRITE(16,*) ' '
 	DO 60, J=1,NY
 	  WRITE(16,80) LABELY(J)-DY,'-',LABELY(J),
     *' : ',(FREQ(I,J),I=1,NX)
 60	CONTINUE
 50	FORMAT(A20)
 70	FORMAT(A3,60(F4.1,A1,F4.1,1X))
 80	FORMAT(F4.1,A1,F4.1,A3,60(I4,1X))
C
 	STOP
	END